#include<iostream>
#include <stdio.h>
#include <stdlib.h>
#include "annUse.h"




annUse::annUse(Image* A, int taillVoisi){
 
  N=taillVoisi;
  dim=3*N*N;//3 : RGB
  k=1;
  eps=0;
  
  nPts= (A->width)*(A->height);
  dataPts = annAllocPts(nPts, dim);
  nnIdx = new ANNidx[k];
  dists = new ANNdist[k];
  
  int i=0;
  for(int y=0; y<A->height  ; y++){
    for(int x=0; x<A->width; x++)
      {
	dataPts[i]=makeANNPointInit(A,x,y);
	i++;
      }
  }
  kdTree = new ANNkd_tree( dataPts, nPts, dim);	
  
}

annUse::~annUse()
{
  delete [] nnIdx;
  delete [] dists;
  delete kdTree;
  annClose();
}

Point* annUse::bestApproximateMatch(Image* B, Point* q,Image* A, float angle, float norme)
{
  ANNpoint queryPt = makeANNPoint(B,q->abs,q->ord,A,angle,norme);
  kdTree->annkSearch(queryPt, 1, nnIdx, dists, eps);	
  
  uint32 x=nnIdx[0]%(A->width);
  uint32 y=nnIdx[0]/(A->width);
  annDeallocPt(queryPt);
  return new Point(x,y);
}


ANNpoint annUse::makeANNPointInit(Image* I, int x, int y)
{
  ANNpoint p;
  p = annAllocPt(dim);
  
  int j=0;
  int f,l;
  int w=I->width;
  int h=I->height;
  for(f=-N/2;f<N/2+1;f++){
    for(l=-N/2;l<N/2+1;l++){
      
      p[j]=(((I->pixel((x+f+w)%w,(y+l+h)%h)) >> 16) & 0x000000FF);
      j++;
      p[j]=(((I->pixel((x+f+w)%w,(y+l+h)%h)) >> 8) & 0x000000FF);
      j++;
      p[j]=((I->pixel((x+f+w)%w,(y+l+h)%h)) & 0x000000FF);
      j++;
      
    }
  }
  return p;
}


ANNpoint annUse::makeANNPoint(Image* I, int abs, int ord, Image* E, float angle,float norme)
{
  ANNpoint p;
  p = annAllocPt(dim);
  
  int j=0;
  int f,l;
  float fr,lr;
  int w=I->width;
  int h=I->height;
  int wE=E->width;
  int hE=E->height;
  float x,y,temp;
  int xE,yE;
  int indiceE;
  int couleur=0;
  float rouge=0.0,vert=0.0,bleu=0.0;
  int a,b;
  float coef;
  for(f=-N/2;f<N/2+1;f++){
    for(l=-N/2;l<N/2+1;l++){      
      fr= norme*( f*cosf(angle)-l*sinf(angle));
      lr= norme*( f*sinf(angle)+l*cosf(angle));
      for(a=0;a<2;a++){
	for(b=0;b<2;b++){
	  temp=abs+fr+2*w;
	  x=((int)temp)%w+temp-(int)temp;//abscisse pt image
	  temp=ord+lr+2*h;
	  y=((int)temp)%h+temp-(int)temp;//ordonnée pt image
	  
	  
	  coef=((1-x+((int) x))*(1-a)+(x-(int) x)*a)*((1-y+(int) y)*(1-b)+(y-(int) y)*b);
	  
	 
	  indiceE=I->pixel( ((int) x + a)%w,((int) y + b)%h);
	  xE=((indiceE)/wE+2*wE)%wE;
	  yE=(indiceE+2*wE)%wE;
	  couleur=E->pixel(xE,yE);
	  rouge+=((couleur >> 16) & 0x000000FF)*coef;
	  vert+=((couleur >> 8) & 0x000000FF)*coef;
	  bleu+=(couleur & 0x000000FF)*coef;
	}
      }
      
      p[j]=(int) rouge;
      j++;
      p[j]=(int) vert;
      j++;
      p[j]=(int) bleu;
      j++;
      rouge=0;
      vert=0;
      bleu=0;
    }
  }
  return p;
}

