#ifndef __IMAGE__
#define __IMAGE__
 
#include <string>
#include <string.h>
#include <stdlib.h>
#include <vector>
#include <iostream>
#include <math.h>
#include <stdio.h>
#include "tiffio.h"
#include "loadSaveTiff.h"
#include <limits.h>
#include "fctauxi.h"

class Image
{
  
 public:	
  
  //attributs
  int width;	
  int height;
  int* image;

  //constructeur
  Image(int w, int h);  	
  //constructeur par default, creer une image de taille w x h
  Image(char* fichier);
  //chargement du fichier dans un nouvel objet.

  //accesseurs
  int getWidth();
  int getHeight();  
  int pixel(int i, int j);
  int pixelfloat(float i, float j);
  
  //modificateurs
  void setpixel(int i, int j, int couleur);
  

  //methodes
  void save_image(char* fichier);  
  //sauvergarde de l'image dans un fichier
  Image* copie(int nb);
  //recopie l'image nb*nb fois.
  Image* E2S();
  //renvoit l'image des coordonnées
  Image* S2E(Image* exemplaire);
  //Calcul l'image I correspondant a l'image this consideré comme une image stockant des pointeurs
  // vers l'image exemplaire

  Image* Upsample(); 
  //multiplie la taille de l'image par 2
  Image* Ssubsample(int widthE);
  //divise une image de pointeurs par 2
  Image* SUpsample(int widthE);  
  //multiplie la taille d'une image de pointeurs par 2
  Image* Subsample();  
  //divise la taille d'une image par 2
  Image* Subsample(float div);  
  //divise la taille d'une image par div
  void Jitter(Image* exemplaire, int coef);
  //this est souvent une image de pointeurs, Jitter perturbe aléatoirement les pointeurs avec
  //une puissance de coef
  int Diffvoisinage(int iE, int jE, int iS, int jS, int k, Image* exemplaire);
  //calcul la norme de this-exemplaire au voisinage des pixels (iE,jE) et (iS,jS)
  void Correction(Image* exemplaire, int taillVoisi);
  //corrige l'image par rappor a l'exemplaire exemplaire et avec un voisinage de taille
  //taillVoisi
  Image* rotate(float degre);
  //applique une rotation d'angle degre a l'image*


  // Destructeur
  ~Image() {}

	

};

#endif
