#include "vecteur.h"
#define PI 3.14159265


Vecteur::Vecteur(int w, int h){
  width=w;
  height=h;
  normes=(float*) malloc ( w  * h * sizeof(float));
  angles=(float*) malloc ( w  * h * sizeof(float));
  
}
Vecteur* Vecteur::Subsample(){
   
  Vecteur* temp=new Vecteur(width/2, height/2);
  int i,j;
  float p1,p2,p3,p4,pres,m1,m2,m3,m4,mres;
  for(i=0;i<temp->width;i++){
    for(j=0;j<temp->height;j++){
      p1=this->angle(2*i,2*j);
      p2=this->angle(2*i+1,2*j);
      p3=this->angle(2*i,2*j+1);
      p4=this->angle(2*i+1,2*j+1);
     
      m1=this->norme(2*i,2*j);
      m2=this->norme(2*i+1,2*j);
      m3=this->norme(2*i,2*j+1);
      m4=this->norme(2*i+1,2*j+1);    
      
      pres=(p1+p2+p3+p4)/4.0;
      mres=(m1+m2+m3+m4)/4.0;
	
      temp->setangle(i,j,pres);
      temp->setnorme(i,j,mres);
    }
  }
  return temp;
}

Vecteur::Vecteur(int w, int h, string modele, int numero){
  int i,j;
  width=w;
  height=h;
  normes=(float*) malloc ( w  * h * sizeof(float));
  angles=(float*) malloc ( w  * h * sizeof(float));
  
  if(modele=="demi_cercle"){
    //de Pi/2 a -Pi/2 sur chaque ligne
    for(i=0;i<w;i++){
      for(j=0;j<h;j++){
	
	this->setangle(i,j,PI/2.0-j*PI/w);
	this->setnorme(i,j,2.5);
      }
    }
  }else if (modele=="demi_cercle_normedecroi"){
    for(i=0;i<w;i++){
      for(j=0;j<h;j++){
	
	this->setangle(i,j,PI/4.0-j*PI/(2.0*w));
	//if (i==0) printf("angle[%02d]=%f\n",j,this->angle(i,j));
	this->setnorme(i,j,2.5*(1-(1.0*j)/(1.0*w))+0.8);
      }
    }
  }else if (modele=="cercle"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	jr=-(1.0*i)+(1.0*h)/2.0;
	ir=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? -atanf(jr/ir)-PI/2 : -atanf(jr/ir)-3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? -PI : PI);
	}
	this->setnorme(i,j,2.5);
      }
    }
  }else if (modele=="bord_tournant"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	jr=-(1.0*i)+(1.0*h)/2.0;
	ir=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? -atanf(jr/ir)-PI/2 : -atanf(jr/ir)-3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? -PI : PI);
	}
	
	if( (jr*jr+ir*ir)<(w*w+h*h)/20.0){//norme 0 au centre norme 2.5 en dehors
	  this->setnorme(i,j,0);
	}else{
	  //printf("%d %d-",i,j);
	  this->setnorme(i,j,3);
	}
      }
    }
  }else if (modele=="centre_tournant"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	jr=-(1.0*i)+(1.0*h)/2.0;
	ir=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? -atanf(jr/ir)-PI/2 : -atanf(jr/ir)-3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? -PI : PI);
	}
	
	if( (jr*jr+ir*ir)<(w*w+h*h)/20.0){//norme 0 au centre norme 2.5 en dehors
	  this->setnorme(i,j,3);
	}else{
	  //printf("%d %d-",i,j);
	  this->setnorme(i,j,0);
	}
      }
    }
  }else if (modele=="trans_d"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	this->setangle(i,j,0);
	this->setnorme(i,j,-3);
	
      }
    }
  }else if (modele=="puit-1"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	ir=-(1.0*i)+(1.0*h)/2.0;
	jr=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? atanf(jr/ir)+PI/2 : atanf(jr/ir)+3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? PI : -PI);
	}
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,-1);
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }
  }else if (modele=="puit1"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	ir=-(1.0*i)+(1.0*h)/2.0;
	jr=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? atanf(jr/ir)+PI/2 : atanf(jr/ir)+3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? PI : -PI);
	}
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,1);
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }
  }else if (modele=="S"){
    int c1i, c2i, c1j, c2j;
    float wi=(float) w;
    c1j=w/2;
    c2j=w/2;
    c1i=(int) w*(1.0/3.0);
    c2i=(int) w*(2.0/3.0);
    int r1, r2, r3, r4;
    r1=(int) ((1.0/12.0)*wi);
    r2=(int) ((3.0/12.0)*wi);
    r3=(int) ((9.0/12.0)*wi);
    r4=(int) ((11.0/12.0)*wi);
    int L=r2-r1;
    int x1,y1,x2,y2;
    float angle2S,angle1S;
    int demicercl1,demicercl2;
    int dc1i,dc2i,dc1j,dc2j;
    dc1i=2*r1;
    dc1j=w-2*r1;
    dc2i=w-2*r1;
    dc2j=2*r1;
    //printf("L %02d, r1 %02d, r2 %02d, r3 %02d, r4 %02d\n",L,r1,r2,r3,r4); 
    for(j=0;j<w;j++){
      for(i=0;i<w;i++){
	y1=(-i+c1i);
	x1=(j-c1j);
	y2=(-i+c2i);
	x2=(j-c2j);
	demicercl1=((Carre(i-dc1i)+Carre(j-dc1j)<Carre(r1))||(j<dc1j));
	demicercl2=((Carre(i-dc2i)+Carre(j-dc2j)<Carre(r1))||(j>dc2j));
	
	if ((((j>=(((200.0-(1.0*numero))/200.0+1)*c1j))||(numero>=200))&&(j>=c1j)&&(i>=r1)&&(i<=r2))&&(demicercl1)){
	  this->setangle(i,j,0);
	  this->setnorme(i,j,5);
	  }else if ((((numero>=1000)||((numero>=800)&&(j>((1000.0-(1.0*numero))/200.0*c1j))))&&(j<=c1j)&&(i>=r3)&&(i<=r4))&&(demicercl2)) {
	  this->setangle(i,j,0);
	  this->setnorme(i,j,5);
	}else if ((j<c1j)&&((Carre(x1)+Carre(y1))<=Carre(r2))&&((Carre(x1)+Carre(y1))>=Carre(r1))) {
	  angle1S=atanf((1.0*y1)/(1.0*x1))+PI/2.0;
	  
	  if ((numero>=500)||((angle1S<PI*((numero*1.0)-200.0)/300.0)&&(numero>200))){
	    this->setangle(i,j,angle1S);
	    this->setnorme(i,j,5);
	  }else{
	    this->setangle(i,j,0);
	    this->setnorme(i,j,0);
	  }
	  

	}else if ((j>=c1j)&&((Carre(x2)+Carre(y2))<=Carre(r2))&&((Carre(x2)+Carre(y2))>=Carre(r1))) {
	  
	  y2>0 ? angle2S=atanf((1.0*y2)/(1.0*x2))-PI/2.0 : angle2S=atanf((1.0*y2)/(1.0*x2))-PI-PI/2.0;
	  if ((numero>=800)||((numero>500)&&(numero<=650)&&(angle2S>=(1-((numero*1.0)-500.0)/150.0)*PI/2.0-PI/2.0))||((numero>650)&&(numero<=800)&&(angle2S>=-((numero*1.0)-650.0)/150.0*PI/2.0-PI-PI/2.0))){
	    this->setangle(i,j,angle2S);
	    this->setnorme(i,j,y2>0 ? -5 : 5);
	  }else{
	    this->setangle(i,j,0);
	    this->setnorme(i,j,0);
	  }
	}else{
	  this->setangle(i,j,0);
	  this->setnorme(i,j,0);
	}
	
      }
    }
  }else{
    printf("attention modele d'animation inexistant\n");
  }
}


Vecteur::Vecteur(int w, int h, string modele){
  int i,j;
  width=w;
  height=h;
  normes=(float*) malloc ( w  * h * sizeof(float));
  angles=(float*) malloc ( w  * h * sizeof(float));
  
  if(modele=="demi_cercle"){
    for(i=0;i<w;i++){
      for(j=0;j<h;j++){
	
	this->setangle(i,j,PI/4.0-j*PI/(2.0*w));
	//if (i==0) printf("angle[%02d]=%f\n",j,this->angle(i,j));
	this->setnorme(i,j,1);
      }
    }

  }else if (modele=="demi_cercle_normedecroi"){
    for(i=0;i<w;i++){
      for(j=0;j<h;j++){
	
	this->setangle(i,j,PI/4.0-j*PI/(2.0*w));
	//if (i==0) printf("angle[%02d]=%f\n",j,this->angle(i,j));
	this->setnorme(i,j,1.5*(1-(1.0*j)/(1.0*w))+0.3);
      }
    }
  }else if (modele=="null"){
    for(i=0;i<w;i++){
      for(j=0;j<h;j++){
	this->setangle(i,j,0);
	this->setnorme(i,j,1);
      }
    }
  }else if (modele=="riviere"){
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	this->setangle(i,j,(PI/4-j*PI/(2*w))*(2*i-h)/h);
	this->setnorme(i,j,1);
      }
    }

  }else if (modele=="puit"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	ir=-(1.0*i)+(1.0*h)/2.0;
	jr=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? atanf(jr/ir)+PI/2 : atanf(jr/ir)+3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? PI : -PI);
	}
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,sqrtf((jr*jr+ir*ir)/(h*h+w*w))+0.3);
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }

  }else if (modele=="puit1"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	ir=-(1.0*i)+(1.0*h)/2.0;
	jr=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? atanf(jr/ir)+PI/2 : atanf(jr/ir)+3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? PI : -PI);
	}
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,1);
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }

  }else if (modele=="cercle"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	jr=-(1.0*i)+(1.0*h)/2.0;
	ir=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? -atanf(jr/ir)-PI/2 : -atanf(jr/ir)-3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? -PI : PI);
	}
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,1);//sqrtf((jr*jr+ir*ir)/(h*h+w*w))+0.3);
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }

  }else if (modele=="anticerclepuit"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	jr=-(1.0*i)+(1.0*h)/2.0;
	ir=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? atanf(jr/ir)+PI/2 : atanf(jr/ir)+3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? PI : -PI);
	}
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,sqrtf((jr*jr+ir*ir)/(h*h+w*w))+0.3);
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }

  }else if (modele=="anticercle"){
    float ir,jr;
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	jr=-(1.0*i)+(1.0*h)/2.0;
	ir=-((1.0*j)-(1.0*w)/2.0);
	if (ir!=0){
	  this->setangle(i,j,ir>0? atanf(jr/ir)+PI/2 : atanf(jr/ir)+3*PI/2);
	}else{
	  this->setangle(i,j,jr>0? PI : -PI);
	}
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,1);
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }

  }else if (modele=="agrandi_lateral"){
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	this->setangle(i,j,0);
	//if (i==0) printf("angle[%02d]=%f\t",j,this->angle(i,j));
	this->setnorme(i,j,0.7+1.5*(1.0*j)/(1.0*w));
	//if (i==0) printf("norme[%02d]=%f\n",j,this->norme(i,j));
      }
    }
  


  }else if (modele=="angle"){
    for(i=0;i<w;i++){
      for(j=0;j<w;j++){
	this->setangle(i,j,-PI/4);
	this->setnorme(i,j,1);
      }
    }
  }else{
    printf("attention utilisation du modele par defaut\n");
    for(i=0;i<w;i++){
      for(j=0;j<h;j++){
	this->setangle(i,j,0);
	this->setnorme(i,j,1);
      }
    }
  }

}


int Vecteur::getWidth() { return width;}
int Vecteur::getHeight() {return height;}
  
float Vecteur::angle(int i, int j){
  if(i>=height || j>=width || j<0 || i<0){
    std::cout << width << " " << j << "  +  " << height <<" " << i << std::endl;
    printf("taille incompatible pour acceder a cet angle\n");
  }else{
    return (angles)[i*width+j];
  }
}

float Vecteur::norme(int i, int j){
  if(i>=height || j>=width || j<0 || i<0){
    std::cout << width << " " << j << "  +  " << height <<" " << i << std::endl;
    printf("taille incompatible pour acceder a cette norme\n");
  }else{
    return (normes)[i*width+j];
  }
}
	
void Vecteur::setnorme(int i, int j, float norme){
  if(i>height || j>width || j<0 || i<0){
    printf("taille incompatible pour ecrire dans cette norme\n");
  }else{
    (normes)[i*width+j]=norme;
  }
}


void Vecteur::setangle(int i, int j, float angle){
  if(i>height || j>width || j<0 || i<0){
    printf("taille incompatible pour ecrire dans cet angle\n");
  }else{
    (angles)[i*width+j]=angle;
  }
}
